Package net.sf.saxon.tree.wrapper

## Class AbstractVirtualNode

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractVirtualNode

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `NodeInfo`, `Sequence`, `Location`, `VirtualNode`, `org.xml.sax.Locator`
  Direct Known Subclasses:
    `RebasedNode`, `SpaceStrippedNode`, `TypeStrippedNode`

      public abstract class AbstractVirtualNode
      extends java.lang.Object
      implements VirtualNode

  AbstractVirtualNode is an abstract superclass for VirtualNode implementations in which the underlying node is itself a Saxon NodeInfo.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected TreeInfo` | `docWrapper` |
    `protected NodeInfo` | `node` |
    `protected AbstractVirtualNode` | `parent` |

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractVirtualNode()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AtomicSequence` | `atomize()` | Get the typed value.
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `boolean` | `equals​(java.lang.Object other)` | The equals() method compares nodes for identity.
    `void` | `generateId​(FastStringBuffer buffer)` | Get a character string that uniquely identifies this node.
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node
    `java.lang.String` | `getBaseURI()` | Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
    `int` | `getColumnNumber()` | Get column number
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace undeclarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node.
    `int` | `getFingerprint()` | Get the fingerprint of the node
    `int` | `getLineNumber()` | Get line number
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `int` | `getNodeKind()` | Return the type of node.
    `java.lang.String` | `getPrefix()` | Get the prefix of the name of the node.
    `java.lang.Object` | `getRealNode()` | Get the node underlying this virtual node.
    `NodeInfo` | `getRoot()` | Get the root node
    `SchemaType` | `getSchemaType()` | Get the type annotation
    `java.lang.String` | `getStringValue()` | Return the string value of the node.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the value of the item as a CharSequence.
    `java.lang.String` | `getSystemId()` | Get the System ID for the node.
    `TreeInfo` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `NodeInfo` | `getUnderlyingNode()` | Get the underlying node, to implement the VirtualNode interface
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `hasFingerprint()` | Test whether a fingerprint is available for the node name
    `int` | `hashCode()` | The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
    `boolean` | `isId()` | Determine whether this node has the is-id property
    `boolean` | `isIdref()` | Determine whether this node has the is-idref property
    `boolean` | `isNilled()` | Determine whether the node has the is-nilled property
    `AxisIterator` | `iterateAxis​(int axisNumber, java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iteration over the nodes reached by the given axis from this node
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setSystemId​(java.lang.String uri)` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, head, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `attributes, children, children, copy, getConfiguration, getGenre, getParent, getPublicId, isSameNodeInfo, isStreamed, iterateAxis, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Field Detail

    - #### node

          protected NodeInfo node

    - #### parent

          protected AbstractVirtualNode parent

    - #### docWrapper

          protected TreeInfo docWrapper

  - ### Constructor Detail

    - #### AbstractVirtualNode

          public AbstractVirtualNode()

  - ### Method Detail

    - #### getTreeInfo

          public TreeInfo getTreeInfo()

      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Returns:
        the TreeInfo
      Since:
        9.7

    - #### getUnderlyingNode

          public NodeInfo getUnderlyingNode()

      Get the underlying node, to implement the VirtualNode interface
      Specified by:
        `getUnderlyingNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint of the node
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Returns:
        the node's fingerprint, or -1 for an unnamed node
      Throws:
        `java.lang.UnsupportedOperationException` - if this method is called for a node where hasFingerprint() returns false;

    - #### hasFingerprint

          public boolean hasFingerprint()

      Test whether a fingerprint is available for the node name
      Specified by:
        `hasFingerprint` in interface `NodeInfo`
      Returns:
        true if the implementation of this node provides fingerprints.

    - #### getRealNode

          public java.lang.Object getRealNode()

      Get the node underlying this virtual node. If this is a VirtualNode the method will automatically drill down through several layers of wrapping.
      Specified by:
        `getRealNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getNodeKind

          public int getNodeKind()

      Return the type of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### atomize

          public AtomicSequence atomize()
                                 throws XPathException

      Get the typed value.
      Specified by:
        `atomize` in interface `Item`
      Specified by:
        `atomize` in interface `NodeInfo`
      Returns:
        the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
      Since:
        8.5

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation
      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Returns:
        the type annotation of the base node

    - #### equals

          public boolean equals​(java.lang.Object other)

      The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().
      Specified by:
        `equals` in interface `NodeInfo`
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
      Since:
        8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

    - #### hashCode

          public int hashCode()

      The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
      Specified by:
        `hashCode` in interface `NodeInfo`
      Overrides:
        `hashCode` in class `java.lang.Object`
      Since:
        8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the System ID for the node.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

    - #### setSystemId

          public void setSystemId​(java.lang.String uri)

      Specified by:
        `setSystemId` in interface `javax.xml.transform.Source`

    - #### getBaseURI

          public java.lang.String getBaseURI()

      Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. In the JDOM model, base URIs are held only an the document level. We don't currently take any account of xml:base attributes.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Returns:
        the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

    - #### getLineNumber

          public int getLineNumber()

      Get line number
      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the line number of the node in its original source document; or -1 if not available

    - #### getColumnNumber

          public int getColumnNumber()

      Get column number
      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the column number of the node in its original source document; or -1 if not available

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### compareOrder

          public int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### getStringValue

          public final java.lang.String getStringValue()

      Return the string value of the node. The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Specified by:
        `getStringValue` in interface `Item`
      Specified by:
        `getStringValue` in interface `NodeInfo`
      Returns:
        the string value of the node
      See Also:
        `Item.getStringValueCS()`

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns null, except for un unnamed namespace node, which returns "".

    - #### getURI

          public java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, return null. For a node with an empty prefix, return an empty string.

    - #### getPrefix

          public java.lang.String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        The prefix of the name of the node.

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber,
                                          java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iteration over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - the axis to be used
        `nodeTest` - A pattern to be matched by the returned nodes
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node
      Specified by:
        `getRoot` in interface `NodeInfo`
      Returns:
        the NodeInfo representing the root of the tree

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.

      Note: the result is equivalent to `getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()`

      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Returns:
        True if the node has one or more children

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a buffer, into which will be placed a string that uniquely identifies this node, within this document. The calling code prepends information to make the result unique across all documents.

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Returns:
        true if the node is an ID

    - #### isIdref

          public boolean isIdref()

      Determine whether this node has the is-idref property
      Specified by:
        `isIdref` in interface `NodeInfo`
      Returns:
        true if the node is an IDREF or IDREFS element or attribute

    - #### isNilled

          public boolean isNilled()

      Determine whether the node has the is-nilled property
      Specified by:
        `isNilled` in interface `NodeInfo`
      Returns:
        true if the node has the is-nilled property